<?php

namespace Litecms\Advert;

use User;

class Advert
{
    /**
     * $advert object.
     */
    protected $advert;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Advert\Interfaces\AdvertRepositoryInterface $advert)
    {
        $this->advert = $advert;
    }

    /**
     * Returns count of advert.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.advert.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->advert->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\AdvertUserCriteria());
        }

        $advert = $this->advert->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('advert::' . $view, compact('advert'))->render();
    }
}
